#ifndef bqtBSPhh
#define bqtBSPhh

#include <vector>
#include "autoptr"
#include "xyz.hh"

class bsp : public ptrable
{
public:
    /* List of all walls residing inside this square */
    std::vector<unsigned> wallids;
    
    /* Smaller corner, bigger corner, dividing point */
    XYZ p1, p2, middle;
    
    /* Subsquares in eight corners */
    autoptr<bsp> dirs[8]; /* y-+ x-+ z-+ */
    
    inline autoptr<bsp> &nwu() { return dirs[0]; }
    inline autoptr<bsp> &swu() { return dirs[1]; }
    inline autoptr<bsp> &neu() { return dirs[2]; }
    inline autoptr<bsp> &seu() { return dirs[3]; }
    inline autoptr<bsp> &nwd() { return dirs[4]; }
    inline autoptr<bsp> &swd() { return dirs[5]; }
    inline autoptr<bsp> &ned() { return dirs[6]; }
    inline autoptr<bsp> &sed() { return dirs[7]; }

public:
    bsp() { }
    ~bsp() { }
    bsp(const XYZ &a, const XYZ &b, unsigned wc);
    
    /* Splits this node if it seems wise.
     * The parameter is a pointer to the wall list.
     * wallids are indexes to this list.
     */
    void Split(const class MapWall *wallmap);
    
    void SubSplit(autoptr<bsp> &dest, const XYZ &a, const XYZ &b,
                  const class MapWall *wallmap);
};

#endif
