#ifndef bqtMatrixHH
#define bqtMatrixHH

#include "floatdefs.hh"
#include "xyz.hh"

/* Matrix usable for handling 3D-coordinates */
class Matrix
{
    FLOAT val[4][4];
public:
    Matrix();
    Matrix(FLOAT_ARG ax, FLOAT_ARG ay, FLOAT_ARG az);
    Matrix(const class XYZ &axis, FLOAT_ARG ang);

    void Zero();
    void Identity();
    void InitRotate(FLOAT_ARG ax, FLOAT_ARG ay, FLOAT_ARG az);
    void InitAxisRotate(const class XYZ &axis, FLOAT_ARG ang);
    
    /* Transforms a point for handling with the matrix */
    void Rotate(class XYZ &p) const;
    
    const Matrix operator * (const Matrix &m) const;
    const Matrix &operator *= (const Matrix &m) { return (*this = *this * m); }
};

#endif
